# Class MultiplexInvocationHandler<T>

java.lang.Object
uk.ac.starlink.util.MultiplexInvocationHandler<T>

All Implemented Interfaces:
  `InvocationHandler`

public class MultiplexInvocationHandler<T> extends Object implements InvocationHandler
Used to generate a proxy instance which implements a given interface and delegates its calls to each of a given list of target implementations. The content of the list of targets may be changed during the lifetime of this object, but it's not a good idea to do it while a method is being invoked.

Since:
  6 Jul 2011
Author:
  Mark Taylor

## Constructor Summary

Constructors
Constructor
Description
`MultiplexInvocationHandler(T[] targets)`
Constructor.

## Method Summary

Modifier and Type
Method
Description
`T`
`createMultiplexer(Class<T> clazz)`
Returns a new proxy instance which implements the given interface type, and which uses this handler to execute its methods.
`T[]`
`getTargets()`
Returns the list of delegate implementations.
`Object`
`invoke(Object proxy, Method method, Object[] args)`
Invokes a method by invoking the same method on each of this handler's target instances.
`void`
`setTargets(T[] targets)`
Sets the list of delegate implementations.

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### MultiplexInvocationHandler

public MultiplexInvocationHandler(T[] targets)
Constructor.

Parameters:
  `targets` - target instances

## Method Details

### setTargets

public void setTargets(T[] targets)
Sets the list of delegate implementations.

Parameters:
  `targets` - target instances

### getTargets

public T[] getTargets()
Returns the list of delegate implementations.

Returns:
  target instances

### invoke

public Object invoke(Object proxy, Method method, Object[] args) throws Throwable
Invokes a method by invoking the same method on each of this handler's target instances. If any invocation throws an exception, it is thrown from this method and the method is not invoked on later targets. If the method terminates normally, the return value is the return value of the invocation from the first target.

Specified by:
  `invoke` in interface `InvocationHandler`
Throws:
  `Throwable`

### createMultiplexer

public T createMultiplexer(Class<T> clazz)
Returns a new proxy instance which implements the given interface type, and which uses this handler to execute its methods.

Parameters:
  `clazz` - interface the return value will implement
Returns:
  multiplexing proxy instance